package com.loafle.overflow.service.central.infra;

import java.util.List;

import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.core.model.PageParams;
import com.loafle.overflow.model.infra.Infra;
import com.loafle.overflow.model.probe.Probe;
import com.loafle.overflow.model.target.Target;

import org.springframework.data.domain.Page;

/**
 * Created by insanity on 17. 6. 28.
 */

public interface InfraService {
  Infra regist(Infra infra) throws OverflowException;
  Infra read(Long id) throws OverflowException;
  Page<Infra> readAllByProbeID(Long probeID, PageParams pageParams) throws OverflowException;
  Page<Infra> readAllByDomainID(Long domainID, PageParams pageParams) throws OverflowException;
  List<Target> readAllTargetByDomainID(Long domainID) throws OverflowException;
  List<Target> readAllTargetByProbeList(List<Probe> probeList) throws OverflowException;
  Infra readByTargetID(Long targetID) throws OverflowException;
}
